                ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                ; Início do bloco A vvvvvvvv não alterar para baixo vvvvvvvv
                ; zona de dados
                ORIG 8000h
resultadosA     TAB     16
resultadosB     TAB     16
resultadosC     TAB     16
resultadosD     TAB     16
                ; jogos de teste para a alínea B
Jogo1           STR     476,68,66,63,9,6,3,1,0
Jogo2           STR     476,469,156,78,39,13,3,0
Jogo3           STR     1547,119,102,83,27,1
Jogo4           STR     4389,4370,2185,87,80,40,5,1
Jogo5           STR     3990,570,30,10,2,0
Jogo6           STR     833,17,0
Jogo7           STR     798,399,392,196,49,7,1
Jogo8           STR     1254,114,112,110,108,54,27,9,6,4,2,1
Jogo9           STR     884,68,34,32,16,14,7,1
Jogo10          STR     180,60,56,28,4,2,1
Jogo11          STR     1001,143,132,66,6,3,0
Jogo12          STR     931,912,910,455,91,1
Jogo13          STR     34,17,1
Jogo14          STR     1862,1813,906,453,1
Jogo15          STR     1020,510,255,51,1
Jogo16          STR     3762,3759,537,31,1
                ; colocar jogos
Jogos           STR Jogo1,Jogo2,Jogo3,Jogo4,Jogo5,Jogo6,Jogo7,Jogo8,Jogo9,Jogo10,Jogo11,Jogo12,Jogo13,Jogo14,Jogo15,Jogo16,0
                ; números de teste para a alínea C e D
Numeros         STR 476,66,5179,34,77,24,40,12,1155,6175,2520,1716,1377,7225,7,5,0
                ; zona para retornar as jogadas
jogadas         TAB     16
                ; zona para colocar os números primos 
                ; os jogos não podem ter números superiores ao maior primo
maxNumeros      EQU     1024
primos          TAB     maxNumeros
                ; Final do bloco A ^^^^^^^^^ não alterar para cima ^^^^^^^^^
                ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


jogadasAux      TAB     16


                ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                ; Início do bloco B vvvvvvvv não alterar para baixo vvvvvvvv
                ; zona do código
                ORIG 0000h

                ; inicialização do stack
Inicio:	        MOV R1, fd1fh
                MOV SP, R1
                
                
                ; TESTE alinea A
                MOV R1, maxNumeros
                CALL PrimeirosPrimos     
                MOV R2, resultadosA
                MOV R4, 16               
CicloA:         DEC R1
                MOV R5, M[R1+primos]
                MOV M[R2], R5
                INC R2
                DEC R4
                BR.NZ CicloA
FimA:           Nop
                
                ; TESTE alinea B
                MOV R1, Jogos
                MOV R4, R0               
CicloB:         MOV R2, M[R1]
                CMP R2, R0
                BR.Z FimB
                PUSH R1
                PUSH R4
                CALL ValidarJogoPrimo    
                POP R4
                MOV M[R4+resultadosB], R1
                POP R1
                INC R4
                INC R1
                BR CicloB
FimB:           Nop               
                

                ; TESTE alinea C
                MOV R5, Numeros
                MOV R4, R0               
CicloC:         MOV R2, jogadas
                MOV R1, M[R5]
                CMP R1, R0
                BR.Z FimC
                PUSH R4
                PUSH R5
                CALL JogadasJogoPrimo
                POP R5
                POP R4
                MOV M[R4+resultadosC], R0
CicloC2:        DEC R1
                BR.N CicloC3
                MOV R3, M[R1+jogadas]
                ADD M[R4+resultadosC], R3
                BR CicloC2
CicloC3:        INC R5                  
                INC R4
                BR CicloC
FimC:           Nop

                ; TESTE alinea D
                MOV R5, Numeros
                MOV R4, R0              
CicloD:         MOV R1, M[R5]
                CMP R1, R0
                BR.Z FimD
                PUSH R4
                PUSH R5
                CALL JogoArtificialPrimo
                POP R5
                POP R4
                MOV M[R4+resultadosD], R1
                INC R5                  
                INC R4
                BR CicloD
FimD:           JMP Fim
                ; Final do bloco B ^^^^^^^^^ não alterar para cima ^^^^^^^^^
                ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                
                ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                ; função PrimeirosPrimos solicitada na alínea A
                ; Entrada: R1 - número de primos pretendido; 
                ;          primos - endereço do local onde guardar os números
                ; Saída: resultado no endereço em R2
                ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
PrimeirosPrimos: PUSH R1 ; copiar para o stack, todos os registos são utilizados
                ; código reutilizado da AF11b sem comentários
                ; adicionado o prefixo P a todos os labels
PInicio:        MOV R1, 1 
                MOV R2, R0 
                MOV R3, 4 
                MOV R4, R0
PProxNum:       INC R1 
                CMP R1, R3 
                BR.N PVerificarPrimo 
                INC R2 
                MOV R3, M[R2+primos] 
                MOV R6, R3
                MUL R6, R3 
                BR PProxNum 
PVerificarPrimo: MOV R5, R0 
PContLoop:      CMP R5, R2 
                BR.NN PNovoPrimo 
                MOV R6, R1 
                MOV R7, M[R5+primos] 
                DIV R6, R7
                CMP R7, R0 
                BR.Z PProxNum 
                INC R5 
                BR PContLoop
PNovoPrimo:     MOV M[R4+primos], R1
                INC R4
                CMP R4, M[SP+1] ; valor de R1 passado
                BR.N PProxNum
                POP R1
                RET
                
                ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                ; função ValidarJogoPrimo solicitada na alínea B
                ; Entrada: R2 - endereço com as jogadas
                ;          primos - endereço com os primeiros números primos
                ; Saída: R1 - número de jogadas válidas
                ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ValidarJogoPrimo: MOV R1, R0
                ; algoritmo:
                ; - processar cada jogada de cada vez, com o valor K e W
                ; - validar se K não é já 0 ou 1, terminando
                ; - dividir e subtrair o K por W
                ; - processar a divisão apenas se for inteira
                ; - processar a subtração apenas se for divisor de K
                ; - ver se a divisão ou a subtração está na lista dos primos:
                ;   - caso positivo, incrementar a jogada e repetir
                ;   - c.c. retornar
                
                ; caso o número seja 0 ou 1, não há jogada válida, parar
VJPProx:        MOV R3, M[R2]
                CMP R3, 1
                JMP.NP VJPFim 
                ; R4 fica com a divisão de R2 com o elemento seguinte
                ; R3 fica com a subtração de R2 com o elemento seguinte
                MOV R3, M[R2]
                MOV R4, M[R2+1]
                DIV R3, R4    ; se R4 for zero, a divisão é válida
                CMP R4, R0
                BR.Z VJP1
                MOV R4, R0 ; inutilizar R4, já que não é fator primo
                BR VJPSub
VJP1:           MOV R4, R3
VJPSub:         MOV R3, M[R2]
                SUB R3, M[R2+1]  ; verificar se R3 divide M[R2]
                MOV R5, M[R2]
                MOV R6, R3
                DIV R5, R6
                CMP R6, R0
                BR.Z VJPtstPrimo 
                MOV R3, R0 ; inutilizar R3, já que não é fator do número
                ; caso um destes números seja primo, a jogada é válida,
                ; caso contrário parar
VJPtstPrimo:    MOV R5, primos
VJPprimoR3:     CMP R3, M[R5]
                BR.Z VJPValido
                BR.N VJPTestarR4
                INC R5
                BR VJPprimoR3
VJPTestarR4:    MOV R5, primos
VJPprimoR4:     CMP R4, M[R5]
                BR.Z VJPValido
                BR.N VJPFim ; ambos não primos, parar
                INC R5
                BR VJPprimoR4
VJPValido:      INC R1
                INC R2
                JMP VJPProx
VJPFim:         RET
                
                
                ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                ; função JogadasJogoPrimo solicitada na alínea C
                ; Entrada: R1 - número K a processar
                ;          R2 - endereço no qual as jogadas devem ser colocadas
                ;          primos - endereço com os primeiros números primos
                ; Saída: R1 - número de jogadas; resultado no endereço R2
                ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
JogadasJogoPrimo: MOV R3, R0 ; número de jogadas
                ; algoritmo:
                ; - processar a lista de primos até K, e para os divisiveis por K:
                ;   - W1 = K/primo; W2=K-primo
                ;   - ver se tanto W1 como W2 estão já na lista de jogadas
                ;     se não estiverem, adicionar
                ; - retornar
                MOV R4, primos
JJPprimo:       CMP R1, M[R4]
                BR.N JJPFim ; o primo já ultrapassou K, retornar
                MOV R6, M[R4]
                MOV R5, R1
                DIV R5, R6
                CMP R6, R0
                BR.NZ JJPProx     ; número divisivel, próximo
                ADD R2, R3        ; adicionar a divisão que está em R5
                MOV M[R2], R5
                INC R3            
                MOV R5, R1        ; adicionar a subtração
                SUB R5, M[R4]
                INC R2
                MOV M[R2], R5
                SUB R2, R3
                INC R3            
JJPProx:        INC R4
                BR JJPprimo
JJPFim:         MOV R1, R3
                RET
                

                ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                ; função JogoArtificialPrimo solicitada na alínea D
                ; Entrada: R1 - número K a processar
                ;          primos - endereço com os primeiros números primos
                ; Saída: R1 - valor W, com a jogada para K 
                ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
JogoArtificialPrimo: Nop
                ; algoritmo:
                ; - obter a lista de jogadas
                ; - para cada jogada, ver quantas jogadas origina, mantendo o maior valor
                ; - caso o valor de jogadas seja igual, mater o maior número
                MOV R2, jogadas ; reutilizar a memória alocada para o efeito
                CALL JogadasJogoPrimo ; retorna as jogadas em R1, 
                                      ; o valor K é perdido mas não é preciso
                MOV R7, R0 ; em R7 fica o melhor valor até ao momento
                MOV R6, R0 ; em R6 fica o número de jogadas da melhor jogada
                CMP R1, R0
                BR.Z JAPFim ; não há jogadas válidas logo de início
                MOV R2, jogadas
                ADD R2, R1
                ; processar todas as jogadas, mantendo o melhor valor
JAPcontar:      DEC R1
                BR.N JAPFim
                DEC R2
                PUSH R1
                PUSH R2
                PUSH R6
                PUSH R7
                MOV R1, M[R2]
                MOV R2, jogadasAux
                CALL JogadasJogoPrimo
                MOV R5, R1
                POP R7
                POP R6
                POP R2
                POP R1
                CMP R5,R6
                BR.Z JAPvalor
                BR.N JAPcontar
                ; novo melhor
JAPnovo:        MOV R7, M[R2]
                MOV R6, R5
                BR JAPcontar
JAPvalor:       CMP R7, M[R2]
                BR.N JAPnovo
                BR JAPcontar
JAPFim:         MOV R1, R7
                RET

                ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                ; Início do bloco C vvvvvvvv não alterar para baixo vvvvvvvv
                ; última instrução, não alterar
Fim:            JMP Fim        
                ; Final do bloco C ^^^^^^^^^ não alterar para cima ^^^^^^^^^
                ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
